//	Program name..	Example demonstrating the UIW_MENU class object.
//	Filename......	XWMENU.CPP
//	Version.......	1.0
//	
//	COPYRIGHT (C) 1990.  All Rights Reserved.
//	Zinc Software Incorporated.  Pleasant Grove, Utah  USA
/* This file is part of OpenZinc

OpenZinc is free software: You can redistribute it and/or modify it
 under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the license or
 (at your option) any later version.

OpenZinc is distributed in the hope that it will be useful,
but without ANY WARRANTY; without even the implied warranty of
MARCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Lessor Public license for more details

You should have received a copy of the GNU Lessor Public License
along with OpenZinc. If not, see <http://www.gnu.org/licenses/>.
*/


#include <ui_win.hpp>

static UIW_WINDOW *SampleMenus(UIW_WINDOW *window)
{
	*window
		+ new UIW_TITLE(" Sample menus ", WOF_JUSTIFY_CENTER)

		+ &(*new UIW_PULL_DOWN_MENU(0, WOF_NO_FLAGS, WOAF_NO_FLAGS)
			+ &(*new UIW_PULL_DOWN_ITEM(" Item~1 ", MNF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 1.1", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 1.2", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 1.3", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0))
			+ &(*new UIW_PULL_DOWN_ITEM(" Item~2 ", MNF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 2.1", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 2.2", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 2.3", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0))
			+ &(*new UIW_PULL_DOWN_ITEM(" Item~3 ", MNF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 3.1", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 3.2", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
				+ new UIW_POP_UP_ITEM("Option 3.3", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)))

		+ new UIW_TEXT(43, 1, 20, 5,
			"A pull-down menu is shown at the top of the window.",
			128, TXF_NO_FLAGS, WOF_VIEW_ONLY | WOF_NON_SELECTABLE | WOF_BORDER)

		+ new UIW_PROMPT(2, 1, "Pop-up menu........", WOF_NO_FLAGS)
		+ &(*new UIW_POP_UP_MENU(22, 1, MNF_SELECT_ONE, WOF_BORDER, WOAF_NO_FLAGS)
			+ new UIW_POP_UP_ITEM(" Option 1 ", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM(" Option 2 ", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM(" Option 3 ", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM(" Option 4 ", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM(" Option 5 ", MNIF_NO_FLAGS, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0));

	return (window);
}

main()
{
	// Check and initialize the display to graphics (or text if no graphics).
	UI_DISPLAY *display = new UI_DOS_BGI_DISPLAY();
	if (!display->installed)
	{
		delete display;
		display = new UI_DOS_TEXT_DISPLAY();
	}

	// Initialize the event and screen managers.
	UI_EVENT_MANAGER *eventManager = new UI_EVENT_MANAGER(100, display);
	*eventManager
		+ new UI_BIOS_KEYBOARD
		+ new UI_MS_MOUSE
		+ new UI_CURSOR;

	UI_WINDOW_MANAGER *windowManager =
		new UI_WINDOW_MANAGER(display, eventManager);

	// Create a window in the screen center with text inside.
	int centerX = display->columns / display->cellWidth / 2;
	int centerY = display->lines / display->cellHeight / 2;
	UIW_WINDOW *window = new UIW_WINDOW(centerX - 34, centerY - 6, 67, 11, WOF_NO_FLAGS, WOAF_NO_FLAGS);
	*window
		+ new UIW_BORDER
		+ new UIW_MAXIMIZE_BUTTON
		+ new UIW_MINIMIZE_BUTTON
		+ &(*new UIW_SYSTEM_BUTTON
			+ new UIW_POP_UP_ITEM("~Restore", MNIF_RESTORE, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM("~Move", MNIF_MOVE, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM("~Size", MNIF_SIZE, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM("Mi~nimize", MNIF_MINIMIZE, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM("Ma~ximize", MNIF_MAXIMIZE, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0)
			+ new UIW_POP_UP_ITEM
			+ new UIW_POP_UP_ITEM("~Close", MNIF_CLOSE, BTF_NO_TOGGLE, WOF_NO_FLAGS, 0));
	SampleMenus(window);
	*windowManager + window;

	/* Process the events */
	int ccode;
	UI_EVENT event;
	do
	{
		/* Get a new event */
		eventManager->Get(event, Q_NORMAL);
		ccode = windowManager->Event(event);
	} while (ccode != L_EXIT && ccode != S_NO_OBJECT);

	// Clean up.
	delete windowManager;
	delete eventManager;
	delete display;
}
